/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in 
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2007.  All Rights Reserved.
 *
 * Protege was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu.
 *
 */

package edu.stanford.smi.protege.util;

import java.awt.*;

import javax.swing.*;

/**
 * A component that contains a JTabbedPane and that implements the {@link Validatable} interface.  The Validatable
 * methods are all delegated to each of the tabs in succession.
 *
 * @author    Ray Fergerson <fergerson@smi.stanford.edu>
 */
public class ValidatableTabComponent extends AbstractValidatableComponent {
    private JTabbedPane _tabbedPane;

    public ValidatableTabComponent() {
        setLayout(new BorderLayout());
        _tabbedPane = ComponentFactory.createTabbedPane(true);
        add(_tabbedPane);
    }

    public void addTab(String label, Component c) {
        _tabbedPane.addTab(label, c);
    }

    public void addTab(String label, Component c, String tooltip) {
        _tabbedPane.addTab(label, null, c, tooltip);
    }

    public void addTab(String label, Icon icon, Component c, String tooltip) {
        _tabbedPane.addTab(label, icon, c, tooltip);
    }

    public Component getTab(String label) {
    	int indexOfTab = _tabbedPane.indexOfTab(label);
    	if (indexOfTab >= 0)
    		return _tabbedPane.getComponent(indexOfTab);
    	else return null;    	
    }

    public JTabbedPane getTabbedPane() {
        return _tabbedPane;
    }

    public void saveContents() {
        int nTabs = _tabbedPane.getTabCount();
        for (int i = 0; i < nTabs; ++i) {
            Component c = _tabbedPane.getComponent(i);
            if (c instanceof Validatable) {
                ((Validatable) c).saveContents();
            }
        }
    }

    public boolean validateContents() {
        boolean isValid = true;
        int nTabs = _tabbedPane.getTabCount();
        for (int i = 0; i < nTabs && isValid; ++i) {
            Component c = _tabbedPane.getComponent(i);
            if (c instanceof Validatable) {
                isValid = ((Validatable) c).validateContents();
            }
        }
        return isValid;
    }
}
